gene = "rpoB"
drug = "rifampicin"

#==========
# LIGPLUS
#===========
# Error! No atom records found!

#==========
# PLIP
#===========
aa_plip_rfp = c(429, 432, 491, 487)
aa_plip_rfp_hbond = c(429, 432, 487)

# chainC: equivalent with offset (-6 from 5uhc) accounted
aa_plip_5uhc_rfp = c(430, 452, 483
                 , 491, 432, 433
                 , 448, 450, 459, 487)
aa_plip_5uhc_rfp_hbond = c(432, 433, 448, 450, 459, 487)

#==========
# Arpeggio
#===========
# rfp: 1894
aa_arpeg_rfp = c(170, 428, 429, 430, 431, 432
                 , 433, 435, 445, 448, 450, 452
                 , 453, 458, 483, 487, 491, 604
                 , 607, 674)

##############################################################
remove_pos = c(170, 674, 604)
active_aa_pos = sort(unique(c(aa_plip_rfp
                              , aa_plip_5uhc_rfp
                              , aa_arpeg_rfp)))

active_aa_pos = active_aa_pos[!active_aa_pos%in%remove_pos]
##############################################################
cat("\nNo. of active site residues for gene"
    , gene, ":"
    , length(active_aa_pos)
    , "\nThese are:\n"
    , active_aa_pos)
##############################################################
aa_pos_rfp = sort(unique(c(aa_plip_rfp
                           , aa_plip_5uhc_rfp
                           , aa_arpeg_rfp)))

aa_pos_rfp = aa_pos_rfp[!aa_pos_rfp%in%remove_pos]
aa_pos_drug = aa_pos_rfp

aa_pos_rfp_hbond = sort(unique(c(aa_plip_rfp_hbond
                           , aa_plip_5uhc_rfp_hbond)))

aa_pos_rfp_hbond = aa_pos_rfp_hbond[!aa_pos_rfp_hbond%in%remove_pos]

cat("\n==================================================="
    , "\nActive site residues for", gene, "comprise of..."
    , "\n==================================================="
    , "\nNo. of", drug, "binding residues:" , length(aa_pos_rfp), "\n"
    , aa_pos_rfp
    , "\n\nNO other co-factors or ligands present\n")

##############################################################
# FIXME: these should be populated!
aa_pos_lig1 = NULL
aa_pos_lig2 = NULL
aa_pos_lig3 = NULL
tile_map=data.frame(tile=c("RFP"),
                    tile_colour=c("green"))


####
chain_suffix = ".C"
print(toString(paste0(aa_pos_drug, chain_suffix)))

# # equivalent resiudes on 5uhc:
# active_aa_pos_5uhc = active_aa_pos+6
# active_aa_pos_5uhc
# print(toString(paste0(active_aa_pos_5uhc, chain_suffix)))

